import 'dart:convert';

import 'Address.dart';
import 'GeoCoordinates.dart';

class AddressWithGeoLocation {
  Address? address;
  GeoCoordinates? location;
  AddressWithGeoLocation({
    this.address,
    this.location,
  });


  bool get hasValues {
    return address?.hasAddress == true || location != null;
  }
  
  AddressWithGeoLocation copyWith({
    Address? address,
    GeoCoordinates? location,
  }) {
    return AddressWithGeoLocation(
      address: address ?? this.address,
      location: location ?? this.location,
    );
  }

  Map<String, dynamic> toMap() {
    return {
      'address': address?.toMap(),
      'location': location?.toMap(),
    };
  }

  factory AddressWithGeoLocation.fromMap(Map<String, dynamic> map) {
    return AddressWithGeoLocation(
      address: Address.fromMap(map['address']),
      location: GeoCoordinates.fromMap(map['location']),
    );
  }

  String toJson() => json.encode(toMap());

  factory AddressWithGeoLocation.fromJson(String source) => AddressWithGeoLocation.fromMap(json.decode(source));

  @override
  String toString() => 'AddressWithGeoLocation(address: $address, location: $location)';

  @override
  bool operator ==(Object other) {
    if (identical(this, other)) return true;
  
    return other is AddressWithGeoLocation &&
      other.address == address &&
      other.location == location;
  }

  @override
  int get hashCode => address.hashCode ^ location.hashCode;
}
